/////////////////////////////////////////////////////////////////////////////
//		Archive.c
#include	<windows.h>
#include	"util.h"
#include	"ExArc.h"


/////////////////////////////////////////////////////////
//	錾

//֐̌^
typedef BOOL ( WINAPI *LPARCHIVE )( const HWND, LPCSTR, LPSTR, const DWORD );
typedef	BOOL ( WINAPI *LPCHECK )( LPCSTR, const int );

//萔錾
typedef struct {
	LPCTSTR	szFile;		LPCSTR	szCmd;		LPCSTR	szChk;		int	nChkMode;
} TDLLFUNC;

TDLLFUNC DllFunc[] = {
	{	_T("CAB32.DLL"  ),	"Cab"     ,	"CabCheckArchive"     ,	0	},
	{	_T("7-ZIP32.DLL"),	"SevenZip",	"SevenZipCheckArchive",	0	},
	{	_T("UNZIP32.DLL"),	"UnZip"   ,	"UnZipCheckArchive"   ,	0	},
	{	_T("UNLHA32.DLL"),	"Unlha"   ,	"UnlhaCheckArchive"   ,	0	},
	{	_T("UNRAR32.DLL"),	"Unrar"   ,	"UnrarCheckArchive"   ,	0	},
	{	_T("TAR32.DLL"  ),	"Tar"     ,	"TarCheckArchive"     ,	0	},
};

//ϐ錾
HANDLE	m_hDLL[ID_DLL_MAX];			//DLL̃nh


/////////////////////////////////////////////////////////
//	DLL̊֐

//
VOID	ArcDllInit( VOID )
{
	ID_DLL	idDll;

	//ɊǗDLL̃[h
	for( idDll=0; idDll<ID_DLL_MAX; ++idDll )
		m_hDLL[idDll] = LoadLibrary( DllFunc[idDll].szFile );
}

//I
VOID	ArcDllExit( VOID )
{
	ID_DLL	idDll;
	//ɊǗDLL̊J
	for( idDll=0; idDll<ID_DLL_MAX; ++idDll )
		FreeLibrary( m_hDLL[idDll] );
}

//R}h̎s
INT		ArcDllCommand( ID_DLL idDll, LPCTSTR lpCmdLine )
{
	LPARCHIVE	fnCmd;
	HWND		hWnd;
	INT			nResult;
	CHAR		szCmdLine[512];

	if( m_hDLL[idDll] == NULL )	return	-1;

#if UNICODE
	WideCharToMultiByte( CP_ACP, 0, lpCmdLine, -1, szCmdLine, 512, NULL, NULL );
#else
	lstrcpy( szCmdLine, lpCmdLine );
#endif
	hWnd = GetForegroundWindow();
	EnableWindow( hWnd, FALSE );
	fnCmd = (LPARCHIVE)GetProcAddress( m_hDLL[idDll], DllFunc[idDll].szCmd );
	nResult = fnCmd( hWnd, szCmdLine, NULL, 0 );
	EnableWindow( hWnd, TRUE );
	if( hWnd != GetForegroundWindow() )
		SetForegroundWindow( hWnd );

	return	nResult;
}

//t@C̃`FbN
BOOL	ArcCheckArchive( ID_DLL idDll, LPCTSTR lpFile )
{
	LPCHECK		fnCheck;
	CHAR		szFile[MAX_PATH];

	if( m_hDLL[idDll] == NULL )	return	FALSE;

#if UNICODE
	WideCharToMultiByte( CP_ACP, 0, lpFile, -1, szFile, MAX_PATH, NULL, NULL );
#else
	lstrcpy( szCmdLine, lpFile );
#endif
	fnCheck = (LPCHECK)GetProcAddress( m_hDLL[idDll], DllFunc[idDll].szChk );
	return	fnCheck( szFile, DllFunc[idDll].nChkMode );
}


/////////////////////////////////////////////////////////
//	ɊǗ̊֐

//t@C̓WJ
BOOL	ArcExtractArchive( ID_ARC idArc, LPCTSTR szArchive, LPCTSTR szPath )
{
	ID_DLL		idDll;
	LPCTSTR		lpCmd;
	TCHAR		szCmdLine[512];

	switch( idArc & ~ID_ARC_SFX )
	{
	case ID_ARC_CAB:	idDll = ID_DLL_CAB;		lpCmd = _T("-x"   );	break;
	case ID_ARC_ZIP:	if( m_hDLL[ID_DLL_7ZIP] == NULL )
					{	idDll = ID_DLL_UNZIP;	lpCmd = _T("-x"   );	break;	}
	case ID_ARC_7Z:		idDll = ID_DLL_7ZIP;	lpCmd = _T("x"    );	break;
	case ID_ARC_LHA:	idDll = ID_DLL_UNLHA;	lpCmd = _T("x -a1");	break;
	case ID_ARC_RAR:	idDll = ID_DLL_UNRAR;	lpCmd = _T("-x"   );	break;
	case ID_ARC_TAR:	idDll = ID_DLL_TAR;		lpCmd = _T("xvf"  );	break;
	default:			return	FALSE;
	}

	wsprintf( szCmdLine, _T("%s \x22%s\x22 \x22%s\x22"), lpCmd, szArchive, szPath );
	return	!ArcDllCommand( idDll, szCmdLine );
}

//gq̃`FbN
ID_ARC	ArcCheckFileType( LPCTSTR szFile )
{
	LPCTSTR		lpExt;

	//gq̎擾
	lpExt = lstrrchr( szFile, '\\' );
	if( !lpExt )	lpExt = szFile;
	lpExt = lstrrchr( lpExt, '.' );
	if( !lpExt )	return	ID_ARC_NOT;
	++lpExt;

	//ɂ̔f
	if( lstrstri( _T("cab"), lpExt ) )
		if( ArcCheckArchive( ID_DLL_CAB  , szFile ) )	return	ID_ARC_CAB;
	if( lstrstri( _T("7z"), lpExt ) )
		if( ArcCheckArchive( ID_DLL_7ZIP , szFile ) )	return	ID_ARC_7Z;
	if( lstrstri( _T("zip"), lpExt ) ) {
		if( ArcCheckArchive( ID_DLL_7ZIP , szFile ) )	return	ID_ARC_ZIP;
		if( ArcCheckArchive( ID_DLL_UNZIP, szFile ) )	return	ID_ARC_ZIP;
	}
	if( lstrstri( _T("lzh"), lpExt ) )
		if( ArcCheckArchive( ID_DLL_UNLHA, szFile ) )	return	ID_ARC_LHA;
	if( lstrstri( _T("rar"), lpExt ) )
		if( ArcCheckArchive( ID_DLL_UNRAR, szFile ) )	return	ID_ARC_RAR;
//	if( lstrstri( _T("tar.z.gz.bz2.taz.tgz.tbz.cpio.rpm.deb.a.lib"), lpExt ) )
	if( lstrstri( _T("tar.z.gz.bz2.taz.tgz.tbz"), lpExt ) )
		if( ArcCheckArchive( ID_DLL_TAR  , szFile ) )	return	ID_ARC_TAR;

	//ȉ𓀏ɂ̔f
	if( lstrstri( _T("exe"), lpExt ) )	{
		if( ArcCheckArchive( ID_DLL_CAB  , szFile ) )	return	ID_ARC_CAB | ID_ARC_SFX;
		if( ArcCheckArchive( ID_DLL_7ZIP , szFile ) )	return	ID_ARC_7Z  | ID_ARC_SFX;
		if( ArcCheckArchive( ID_DLL_UNZIP, szFile ) )	return	ID_ARC_ZIP | ID_ARC_SFX;
		if( ArcCheckArchive( ID_DLL_UNLHA, szFile ) )	return	ID_ARC_LHA | ID_ARC_SFX;
		if( ArcCheckArchive( ID_DLL_UNRAR, szFile ) )	return	ID_ARC_RAR | ID_ARC_SFX;
	}

	return	ID_ARC_NOT;
}
